unit preprocessvars;
{Accepts any string containing <VAR> </VAR> lists and creates accordingly}

interface
 uses classes,sysutils,lowx,strutils,PreprocessorUtils;

procedure processVariables (data:String;var VariableList:tstringlist) ;
function produceVarStatement (data:String):String;

implementation

procedure processVariables (data:String;var VariableList:tstringlist);
var hold:String;
begin
 hold:=GetTagData (data,'VAR');
 hold:=trim(hold);
 if length(hold)>0 then
   if hold[length(hold)] <>';' then hold:=hold+';' ;
 while pos(';',hold)<>0 do hold:=replacestring(hold,';',#13+#10);
 if hold<>'' then
   if assigned(variablelist) then
       VariableList.add(hold );
   {a list of 'name:type'}
end;

procedure processVariablestoObjects (data:String;var VariableList:tstringlist);
var hold,name,vartype:String; holdlist:tstringlist; i:integer;parm:TPSPParameter;
begin
 holdlist:=tstringlist.create;
 processVariables (data,holdlist);
 for i:= 0 to holdlist.count-1 do
  begin
    holdlist[i]:=replacestring(holdlist[i],':','=');
  end;
 Variablelist.clear;
 for i:= 0 to holdlist.count-1 do
  begin
    name:=holdlist.names[i];
    vartype := holdlist.values[name];
    parm:=TPSPParameter.create;
    parm.name:=name;
    parm.vartype:=vartype;
    Variablelist.addobject (name,parm);
  end;
 holdlist.clear;
 holdlist.free;
end;

function produceVarStatement (data:String):String;
var vList:TStringlist;i:integer;outhold:String;
begin
 vlist:=tstringlist.create;
 vlist.text:='';
 processVariables (data,vlist);
   if assigned(vlist) then
 for i:= 0 to vlist.count-1 do
  begin
   while pos(#13+#10,vlist[i])<>0 do vlist[i]:=replacestring(vlist[i],#13+#10,'');
   outhold:='    '+vlist[i]+'; '+#13+#10;
  end;
  if outhold<>'' then
    outhold:='var' + #13+#10 + outhold;
 if assigned(vlist) then vlist.clear;
  if assigned(vlist) then vlist.free;
 result:=outhold;
end;


end.